﻿using Prism.Ioc;
using Prism.Modularity;
using Prism.Regions;

using TestModule.ViewModels;
using TestModule.Views;

namespace TestModule
{
    /// <summary>
    /// 테스트 모듈 모듈
    /// </summary>
    public class TestModuleModule : IModule
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 초기화시 처리하기 - OnInitialized(containerProvider)

        /// <summary>
        /// 초기화시 처리하기
        /// </summary>
        /// <param name="containerProvider">컨테이너 제공자</param>
        public void OnInitialized(IContainerProvider containerProvider)
        {
            IRegionManager regionManager = containerProvider.Resolve<IRegionManager>();

            IRegion region = regionManager.Regions["ContentRegion"];

            TabView tabViewA = containerProvider.Resolve<TabView>();

            SetTitle(tabViewA, "Tab A");

            region.Add(tabViewA);

            TabView tabViewB = containerProvider.Resolve<TabView>();

            SetTitle(tabViewB, "Tab B");

            region.Add(tabViewB);

            TabView tabViewC = containerProvider.Resolve<TabView>();

            SetTitle(tabViewC, "Tab C");

            region.Add(tabViewC);
        }

        #endregion
        #region 타입 등록하기 - RegisterTypes(containerRegistry)

        /// <summary>
        /// 타입 등록하기
        /// </summary>
        /// <param name="containerRegistry">컨테이너 레지스트리 인터페이스</param>
        public void RegisterTypes(IContainerRegistry containerRegistry)
        {
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 제목 설정하기 - SetTitle(tabView, title)

        /// <summary>
        /// 제목 설정하기
        /// </summary>
        /// <param name="tabView">탭 뷰</param>
        /// <param name="title">제목</param>
        private void SetTitle(TabView tabView, string title)
        {
            (tabView.DataContext as TabViewModel).Title = title;
        }

        #endregion
    }
}