﻿using Prism.Mvvm;

using TestLibrary;

namespace TestProject.ViewModels
{
    /// <summary>
    /// 메인 윈도우 뷰 모델
    /// </summary>
    public class MainWindowViewModel : BindableBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 애플리케이션 명령
        /// </summary>
        private IApplicationCommand applicationCommand;

        /// <summary>
        /// 제목
        /// </summary>
        private string title = "IActiveAware 인터페이스 : 활성 명령만 호출하기";

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 제목 - Title

        /// <summary>
        /// 제목
        /// </summary>
        public string Title
        {
            get
            {
                return this.title;
            }
            set
            {
                SetProperty(ref this.title, value);
            }
        }

        #endregion
        #region 애플리케이션 명령 - ApplicationCommand

        /// <summary>
        /// 애플리케이션 명령
        /// </summary>
        public IApplicationCommand ApplicationCommand
        {
            get
            {
                return this.applicationCommand;
            }
            set
            {
                SetProperty(ref this.applicationCommand, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindowViewModel(applicationCommand)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="applicationCommand">애플리케이션 명령</param>
        public MainWindowViewModel(IApplicationCommand applicationCommand)
        {
            ApplicationCommand = applicationCommand;
        }

        #endregion
    }
}